#include "my.h"
#include "label.h"

extern CBorder;
extern CDump;
extern CDump1;
extern word AddrDUMP;

int DX=0,DSY=0;
/*              0 1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34*/
int DXPos [35]={0,8,11,16,19,22,25,28,31,34,37,40,43,46,49,52,55,58,61,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79};
int DXSize[35]={7,2, 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};


word BuildDMPLine(char *buf,word a)
{
 byte b;
 _Label *L;
 char *bptr;
 int i;

 *buf='\0';
 if (L=FindAddrLabel(a)) _strcpy(buf,L->Name);
 _strncat(buf,"         ",8-_strlen(buf));
 _strcat(buf,"00.");
 bptr=buf+11;
 bptr=PutWORD(bptr,a);

 for (i=0;i<16;i++)
 {
  b=RdZ80(a++);
  bptr=PutCHAR(bptr,' ');bptr=PutBYTE(bptr,b);
  buf[64+i]=AIF(b);
 }
 buf[63]='';buf[80]='\0';
 return a;
}



void UpdateDUMP()
{
 word a;
 char buf[128];
 int i,j,y=0;

 a=AddrDUMP;
 while (y<8)
   {
    a=BuildDMPLine(buf,a);
    ScreenPutString(buf,CDump,0,17+y);
    ScreenPutString("",CBorder,63,17+y++);
  }
}
void DCsrUP() { if (DSY) DSY--; else AddrDUMP-=16;return;}
void DCsrDown() { if (DSY<7) DSY++; else AddrDUMP+=16;return;}


void doDUMP()
{
 int i;
 char tmp[128];
 int update=1;
 int ea;
 int ex;
 int Key;


 for(;;)
 {
  if (update) UpdateScreen(); else UpdateDUMP();
  update=0;

  BuildDMPLine(tmp,AddrDUMP+(DSY<<4));
  tmp[DXPos[DX]+DXSize[DX]]='\0';
  ScreenPutString(tmp+DXPos[DX],CDump1,DXPos[DX],DSY+17);

  switch (Key=getxkey())
    {
     case K_Escape: {return;}
     case K_Control_Right:
     case K_Control_ERight: {AddrDUMP++;break;}
     case K_Control_Left:
     case K_Control_ELeft: {AddrDUMP--;break;}
     case K_Right:
     case K_ERight: {if (DX<34) DX++; else DX=0;break;}
     case K_Left:
     case K_ELeft: {if (DX) DX--; else DX=34;break;}
     case K_EUp:
     case K_Up:     { DCsrUP(); break;}
     case K_EDown:
     case K_Down:   { DCsrDown();break;}
     case K_EPageDown:
     case K_PageDown: {for(i=0;i<7;i++) DCsrDown();break;}
     case K_EPageUp:
     case K_PageUp: {for(i=0;i<7;i++) DCsrUP();break;}

     case K_Tab:    { if (DX<3) {DX++;break;}
                      if (DX>2 && DX<19) DX=19-3+DX;
                      else if (DX>18) DX=3+DX-19;
                      break;
                    }

     case K_Return:
          {
           switch (DX)
             {
              case 0: {break;} // Label
              case 1: {break;} // Page
              case 2:
                   {
                    ea=EditWORD(AddrDUMP+(DSY<<4),DXPos[DX],DSY+17);
                    AddrDUMP=ea-(DSY<<4);break;
                   }
              default:
                   {
                    if (DX>2 && DX<19)     // Hex Dump
                      {
                       ex=1;
                       while (DX<19 && ex>=0)
                         {
                          ex=GetBYTE(RdZ80(AddrDUMP+(DSY<<4)+DX-3),DXPos[DX],DSY+17);
                          if (ex>=0)
                            {
                             WrZ80(AddrDUMP+(DSY<<4)+DX-3,ex);
                             UpdateScreen();
                             DX++;
                            }
                         }
                       if (DX==19) DX--;
                       update=1;
                       break;
                      }
                    else                 // Text Dump
                      {
                       break;
                      }
                   }
             } // Switch DX
           break;
          } // K_Return

     default:
          {
           if (DX>=19) // all key in Text DUMP
             {
              if ( (Key == AIF(Key)) || (Key == '') )
                   {
                    WrZ80(AddrDUMP+(DSY<<4)+DX-19,Key);
                    if (DX<34) DX++;
                    update=1;
                   }
             }
          } // default
    }
  }
}
