/**************************************************************************

                           TAP Loader

**************************************************************************/

#include "emudata.h"


EmuData *TblData;
unsigned Id;

#define KEYOFF (23)
char _DSC[]   =".TAP Loader v0.7, Key:F7  "; // ᠭ
char BADVERS[]="For version 3.03+ :-(";

char Title[]  =".TAP Loader v0.6"; // Windows Title


// ப  䥩
char TxtOk[]="OK";
char TxtCancel[]="Cancel";
char TxtBrowse[]="Browse";
void (*OldProc)();
byte OLD_ROM[17]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

unsigned Key=0x2;

char Path[80];
char FileName[80];
byte TapeSelect=0;
unsigned OkEmulVersion=1;

static void WorkMenu(void);



struct CnTxt CtFileName={FileName,80};

char TxtKey[]="\001Key:\nF7\nF8\nF9\nF10\nF11\nF12";
static const char *CKey[]={"F7","F8","F9","F10","F11","F12"};
struct CnTbl CgKey={&Key,CKey,sizeof CKey/sizeof(char*)};

//  䨣樨
static struct CfgS Cfg[]={
    TTbl,"ESL_TAPL_Key=",&CgKey,
    TTxt,"ESL_TAPL_FileName=",&CtFileName
};

struct CfgDat _CFG={Cfg,sizeof Cfg/sizeof(CfgS)}; //   䨣樨


//  䠩
int Handle;

//    ⭠ 祭
static const char SymHex[]={
	'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
};

// ॢ 祭  ப
static void HexToStr(unsigned Val,char *Txt,int Num) {
	Txt+=Num-1;
	while (Num--) {
		*Txt--=SymHex[Val&0xF];
		Val>>=4;
	}
};

// ⨥ 䠩
unsigned FileOpen(char *Name);
#pragma aux FileOpen=\
    "   mov ax,0x3d00"\
	"	xor ecx,ecx"\
	"	int 0x21"\
    "   jnc $"\
    "   neg eax"\
    "$:"\
	modify [eax ecx] parm [edx] value [eax]


//  䠩
unsigned FileCreate(char *Name);
#pragma aux FileCreate=\
	"	mov ah,0x3C"\
	"	xor ecx,ecx"\
	"	int 0x21"\
	modify [eax ecx] parm [edx] value [eax]

// ⥭ 䠩
unsigned FileRead(void *Buf,unsigned Size,unsigned Handle);
#pragma aux FileRead=\
    "   mov ah,0x3f"\
	"	int 0x21"\
    modify [eax] parm [edx][ecx][ebx] value [eax]

//  䠩
void FileSave(void *Buf,unsigned Size,unsigned Handle);
#pragma aux FileSave=\
	"	mov ah,0x40"\
	"	int 0x21"\
	modify [eax] parm [edx][ecx][ebx]

// ⨥ 䠩
void FileClose(unsigned Handle);
#pragma aux FileClose=\
	"	mov ah,0x3E"\
	"	int 0x21"\
	modify [eax] parm [ebx]

// SEEK 䠩
unsigned LSeek(unsigned Handle,unsigned Ptr, byte Type);
#pragma aux LSeek=\
    "   push eax"\
    "   mov al,cl"\
    "   pop dx"\
    "   pop cx"\
    "   mov ah,0x42"\
	"	int 0x21"\
    "   push dx"\
    "   push ax"\
    "   pop ebx"\
    modify [eax edx ecx] parm [ebx] [eax] [ecx] value [ebx]

unsigned RegEDI();
#pragma aux RegEDI="" value [edi]

unsigned RegESI();
#pragma aux RegESI="" value [esi]

unsigned RegEDX();
#pragma aux RegEDX="" value [edx]

unsigned RegECX();
#pragma aux RegECX="" value [ecx]


int TryRead(word Addr,unsigned len, int Type)
{
    struct
    {
        word    Len;
        byte    Type;
    } Hdr;

    int ext=1;
    byte    *buf=TblData->SpecRAM+(0x4000*0x30);

    while ( ext )
    {
        if ( (TapeSelect == 0) || (FileRead(&Hdr,sizeof(Hdr),Handle)) != sizeof(Hdr) )
        {
            LSeek(Handle,0,0);
/*
            TblData->TextMode();
            TblData->MessageBox(0x4F,"End Of Tape, Please open new tape","");
            TblData->SpecMode();

            TapeSelect=0;
*/
//            return 0;
            Hdr.Len=0;
        }

        if ( Hdr.Len == 0 )
        {
//            TapeSelect=0;
            Hdr.Type=2;
        }
        else
        {
            FileRead(buf,Hdr.Len-1,Handle);
            if ( ( Hdr.Type == Type ) /*&& (Hdr.Len-2 == len)*/ ) ext=0;
        }
    }

    for (int i=0;i<len;i++)
    {
        (TblData->SpecSeg[Addr>>0xE])[Addr&0x3FFF]=*buf++;
        Addr++;
    }

    return 1;
}


void _SET() {

    void *Pnt=TblData->WinCreate(29,4,22,17,0x9F);
    TblData->WinTitle(Pnt,Title,0xFC);
    TblData->WinText(Pnt,3,2,"ESL, Kharkov 1997");

    if ( OkEmulVersion )
    {
        TblData->SetRadio(Pnt,8,4,TxtKey,&CgKey);
        TblData->SetButton(Pnt,5,14,TxtCancel,12,0);
        TblData->SetButton(Pnt,5,12,TxtOk,12,1);
    }
    else
    {
        TblData->WinText(Pnt,8,5,"Sorry");
        TblData->WinText(Pnt,9,6,"for");
        TblData->WinText(Pnt,7,7,"version");
        TblData->WinText(Pnt,7,8,">= 3.03");
        TblData->SetButton(Pnt,5,12,TxtOk,12,1);
    }

	if (TblData->WinExe(Pnt)) TblData->WinResult(Pnt);
	TblData->WinRemove(Pnt);

}

void GetPath(char *src,char *dst)
{
    char *SlPos=dst;
    *dst=0;

    while ( *src )
    {
        if ( *src == '\\' ) SlPos=dst;
        *dst++=*src++;
    }
    *SlPos=0;
}

void MakeFullName(char *Name,char *Path)
{
    char *src;
    char *dst;

    src=Name;
    while ( *src ) if ( (*src++) == ':' ) return;

    src=Path; dst=Name;
    while ( *Path ) *Path++;
    *Path++='\\';

    while ( *Name ) *Path++=*Name++;
    *Path=0;

    while ( *src ) *dst++=*src++;
    *dst=0;
}


static void WorkMenu() {

    int Result=-1;

    if ( OkEmulVersion == 0 ) return;

    TblData->TextMode();
    void *Pnt=TblData->WinCreate(8,8,63,12,0x9F);
    TblData->WinTitle(Pnt,Title,0xF4);

    TblData->WinText(Pnt,2,2,"      .TAP file loader by ESL. Kharkov, Ukraine, 1997.");
    TblData->WinText(Pnt,2,3,"                      FidoNet: 2:461/108.7");

    void *TxtPnt=TblData->SetInputTxt(Pnt,4,6,35,"\001File Name",&CtFileName);

    TblData->SetButton(Pnt,44,7,TxtBrowse,12,3);

    TblData->SetButton(Pnt,29,9,TxtCancel,12,0);
    TblData->SetButton(Pnt,13,9,TxtOk,12,1);


    while ( (Result != 0) && (Result != 1) )
    {
        if ( (Result=TblData->WinExe(Pnt)) == 3)
        {
            GetPath(FileName,Path);
            TblData->FileBox(TxtPnt,"*.tap",Path);
        }
        TblData->WinResult(Pnt);
    }
    if (*Path) MakeFullName(FileName,Path);

    TblData->WinRemove(Pnt);

    if ( Result )
    {
        if (TapeSelect) FileClose(Handle);
        TapeSelect=((Handle=FileOpen(FileName))>0)?1:0;
    }
    TblData->SetSpec();
}


void _ON_() {
               //   0    1    2    3    4    5    6    7    8    9    a    b   c
    byte patch[]={0xed,0xff,0xe5,0xf5,0xe1,0x7d,0xe6,0xbf,0x6f,0xe5,0xf1,0xe1,0xc9};
    for (int i=0;i<13;i++)
    {
        if (OLD_ROM[i] == 0) OLD_ROM[i]=*(TblData->SpecROM+(0x4000*1)+0x56a+i);
        *(TblData->SpecROM+(0x4000*1)+0x56a+i)=patch[i];
    }
}

void ED_FF()
{
    unsigned RegPCr,RegSPr,RegAFr,RegFRr;


	RegPCr=RegEDI();
	RegSPr=RegESI();
	RegAFr=RegEDX();
	RegFRr=RegECX();


    if (TapeSelect)
    {
        if (TryRead(TblData->DataCPU.RegIX,TblData->DataCPU.RegDE, TblData->DataCPU.RegAa))
        {
            *(TblData->SpecROM+(0x4000*1)+0x56a+6)=0xf6; // OR #41
            *(TblData->SpecROM+(0x4000*1)+0x56a+7)=0x41; // Cy=1
        }
        else
        {
            *(TblData->SpecROM+(0x4000*1)+0x56a+6)=0xe6;// AND #be
            *(TblData->SpecROM+(0x4000*1)+0x56a+7)=0xbe;// Cy=0
        }
    }
}

void _INI(EmuData *Pnt,unsigned IdN) {

    char *a=_DSC,*b=BADVERS;
    TblData=Pnt;
	Id=IdN;

    OldProc=TblData->OpCPU[0x200+0xff];
    TblData->OpCPU[0x200+0xff]=ED_FF;

    if ( (TblData->VerMajor <= 3) && (TblData->VerMinor < 3) )
    {
        OkEmulVersion=0;
        while (*b) *a++=*b++;
        *a=0;
    }
}



void _UNI() {
    FileClose(Handle);
    TblData->OpCPU[0x200+0xff]=OldProc;

    for (int i=0;i<13;i++)
        *(TblData->SpecROM+(0x4000*1)+0x56a+i)=OLD_ROM[i];
}

void _INS() {
    _DSC[KEYOFF]  =CKey[Key][1];
    _DSC[KEYOFF+1]=CKey[Key][2];
}


void _F7_() {if (Key==0) WorkMenu();}
void _F8_() {if (Key==1) WorkMenu();}
void _F9_() {if (Key==2) WorkMenu();}
void _F10() {if (Key==3) WorkMenu();}
void _F11() {if (Key==4) WorkMenu();}
void _F12() {if (Key==5) WorkMenu();}

