/**************************************************************************

                           FDI Support

Copyright 1997-1999 Sergey Erokhin aka ESL, 2:461/108.7, greatmao@yahoo.com

**************************************************************************/

#include "emudata.h"


EmuData *TblData;
unsigned Id;

char _DSC[]=".FDI Support v0.0"; // ᠭ

// ப  䥩
char TxtOk[]="\001OK";
char TxtCancel[]="\001Cancel";
char TxtBrowse[]="\001Browse";

unsigned Key=0x5;

char Path[80];
char FileName[80];
unsigned Handle;
unsigned HandleLOG;
byte TapeSelect=0;
unsigned spin;
unsigned WrProt=1;
unsigned StatType;

// ---------------------------------------
byte VG_IndexUse=0;
byte IndexFlipFlop=0;
byte VG_Side=0;
byte ReadStat=0;
byte ReadSYS=0;
byte RDADDR[]={0,0,0,0,0,0};
byte *ReadPTR;
unsigned ReadLEN;
unsigned ReadOFF;
byte SecNum=0;
byte *TRACKBUF=0;
byte TrackInBuf=255;
byte RdFLAG;

static void WorkMenu(void);

struct CnTxt CtFileName={FileName,80};

char TxtKey[]="Key:\nF7\nF8\nF9\nF10\nF11\nF12";
static const char *CKey[]={"F7","F8","F9","F10","F11","F12"};
struct CnTbl CgKey={&Key,CKey,sizeof CKey/sizeof(char*)};

//  䨣樨
static struct CfgS Cfg[]={
    TTbl,"ESL_FDI_Key=",&CgKey,
    TTxt,"ESL_FDI_FileName=",&CtFileName
};

struct CfgDat _CFG={Cfg,sizeof Cfg/sizeof(CfgS)}; //   䨣樨

/*-----------------01.12.97 19:54-------------------
                  FDI Header
--------------------------------------------------*/

struct _fdi_head{
    char sig[3];
	char write_enable;
	unsigned short cyl_count;
	unsigned short sides_count;
	unsigned short text_offset;
	unsigned short data_offset;
	unsigned short extra_size;
};


struct _sec_head{
	unsigned char c,h,r,n;
	unsigned char flags;
	unsigned short offs;
};

struct _trk_head{
	long offs;
	unsigned short reserved;
	unsigned char sex;
	struct _sec_head *sec;
};

struct _fdi_head fdi;
struct _trk_head *ftrk;



//    ⭠ 祭
static const char SymHex[]={
	'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'
};

// ॢ 祭  ப
static void HexToStr(unsigned Val,char *Txt,int Num) {
	Txt+=Num-1;
	while (Num--) {
		*Txt--=SymHex[Val&0xF];
		Val>>=4;
	}
};

// ⨥ 䠩
unsigned FileOpen(char *Name);
#pragma aux FileOpen=\
    "   mov ax,0x3d00"\
	"	xor ecx,ecx"\
	"	int 0x21"\
    "   jnc $"\
    "   neg eax"\
    "$:"\
	modify [eax ecx] parm [edx] value [eax]


//  䠩
unsigned FileCreate(char *Name);
#pragma aux FileCreate=\
	"	mov ah,0x3C"\
	"	xor ecx,ecx"\
	"	int 0x21"\
	modify [eax ecx] parm [edx] value [eax]

// ⥭ 䠩
unsigned FileRead(void *Buf,unsigned Size,unsigned Handle);
#pragma aux FileRead=\
    "   mov ah,0x3f"\
	"	int 0x21"\
    modify [eax] parm [edx][ecx][ebx] value [eax]

//  䠩
void FileSave(void *Buf,unsigned Size,unsigned Handle);
#pragma aux FileSave=\
	"	mov ah,0x40"\
	"	int 0x21"\
	modify [eax] parm [edx][ecx][ebx]

// ⨥ 䠩
void FileClose(unsigned Handle);
#pragma aux FileClose=\
	"	mov ah,0x3E"\
	"	int 0x21"\
	modify [eax] parm [ebx]

// SEEK 䠩
unsigned LSeek(unsigned Handle,unsigned Ptr, byte Type);
#pragma aux LSeek=\
    "   push eax"\
    "   mov al,cl"\
    "   pop dx"\
    "   pop cx"\
    "   mov ah,0x42"\
	"	int 0x21"\
    "   push dx"\
    "   push ax"\
    "   pop ebx"\
    modify [eax edx ecx] parm [ebx] [eax] [ecx] value [ebx]

unsigned RegEDI();
#pragma aux RegEDI="" value [edi]

unsigned RegESI();
#pragma aux RegESI="" value [esi]

unsigned RegEDX();
#pragma aux RegEDX="" value [edx]

unsigned RegECX();
#pragma aux RegECX="" value [ecx]



void _SET() {

    if ( TRACKBUF == 0 )
    {
        TblData->TextMode();
        TblData->MessageBox(0x4f,"Error: Can't allocate startup mem","");
        TblData->SpecMode();
        return;
    }

    void *Pnt=TblData->WinCreate(29,4,22,17,0x9F);
    TblData->WinTitle(Pnt,_DSC,0xFC);
    TblData->WinText(Pnt,3,2,"ESL, Kharkov 1997");
    TblData->SetRadio(Pnt,8,4,TxtKey,&CgKey);
    TblData->SetButton(Pnt,5,14,TxtCancel,12,0);
    TblData->SetButton(Pnt,5,12,TxtOk,12,1);
	if (TblData->WinExe(Pnt)) TblData->WinResult(Pnt);
	TblData->WinRemove(Pnt);

}

void GetPath(char *src,char *dst)
{
    char *SlPos=dst;
    *dst=0;

    while ( *src )
    {
        if ( *src == '\\' ) SlPos=dst;
        *dst++=*src++;
    }
    *SlPos=0;
}

void MakeFullName(char *Name,char *Path)
{
    char *src;
    char *dst;

    src=Name;
    while ( *src ) if ( (*src++) == ':' ) return;

    src=Path; dst=Name;
    while ( *Path ) *Path++;
    *Path='\\';
    while ( *Name ) *Path++=*Name++;
    *Path=0;
    while ( *src ) *dst++=*src++;
    *dst=0;
}

void FreeFDIMem(void)
{
    int i;
    if ( ftrk )
    {
        for(i=0; i<fdi.cyl_count * fdi.sides_count; ++i)
            if (ftrk[i].sec) TblData->MemFree(ftrk[i].sec);
        TblData->MemFree(ftrk);
        ftrk=0;
    }
}

int OpenFDI(char *FileName)
{
    char H_FDI[]="00 00 00000000";
    int i,j;
    int err=0;



    TblData->MessageBox(0x4f,"",FileName);
    if ( (Handle = FileOpen(FileName)) == 0 )
    {
        TblData->MessageBox(0x4f,"Error Open File:",FileName);
        return 0;
    }


    FileRead(&fdi,sizeof(fdi),Handle);

    if ( fdi.sig[0]!='F' || fdi.sig[1]!='D' || fdi.sig[2]!='I')
    {
        TblData->MessageBox(0x4f,"Bad Header File:",FileName);
        return 0;
    }

    LSeek(Handle,sizeof(fdi)+fdi.extra_size,0);

    if ( (ftrk = (_trk_head*) TblData->MemAlloc(sizeof(struct _trk_head) * fdi.cyl_count * fdi.sides_count)) == 0 )
    {

        HexToStr((sizeof(struct _trk_head) * fdi.cyl_count * fdi.sides_count),H_FDI,8);
        TblData->MessageBox(0x4f,"Can't alloc mem",H_FDI);
        return 0;
    }

    for(i=0; i<fdi.cyl_count * fdi.sides_count; ++i){
        FileRead(&ftrk[i], sizeof(struct _trk_head) - sizeof(struct _sec_head *),Handle);

        if (ftrk[i].sex)
        {
            if ( (ftrk[i].sec = (_sec_head*) TblData->MemAlloc(sizeof(struct _sec_head) * ftrk[i].sex)) == 0 )
            {
                TblData->MessageBox(0x1f,H_FDI,"");
                err=1;
            }
            else  FileRead(ftrk[i].sec,sizeof(struct _sec_head) * ftrk[i].sex,Handle);
        }
        else ftrk[i].sec=0;

    }

    if ( err == 1)
    {
        TblData->MessageBox(0x4f,"Can't alloc sector mem","");
        FreeFDIMem();
        return 0;
    }

    return 1;
}

/*
    byte DataIO; // 祭, ஥ । १ 
	byte OperIO; //  
	byte RegStatus; //  ﭨ 
	byte RegCom; //  
	signed char RegTrack; //  ஦
	byte RegSect; //  ᥪ
	byte RegData; //  
	byte System; // ⥬ ॣ ஫ ᪮
	signed char StepDirect; // ࠢ 蠣: -01 - ; 01 - ।
	byte TrackReal[4]; //   ᪮
*/


void ResetVG(void)  // Reset
{
    TblData->VG.TrackReal[0]=0;
    TblData->VG.RegStatus=0;// ((spin?1:0)<1) | ( WrProt << 6);
    StatType=0;
}

void Read_TRK(void) { TblData->VG.DataIO=TblData->VG.RegTrack;}
void Read_SEC(void) { TblData->VG.DataIO=TblData->VG.RegSect;}
void Read_SYS(void)
{
    --RdFLAG;if (RdFLAG==0) ReadSYS=0x80;
    TblData->VG.DataIO=ReadSYS;
}
void Read_STAT(void)
{
    IndexFlipFlop^=2;
    TblData->VG.DataIO=(VG_IndexUse & IndexFlipFlop) | ReadStat;
}
void Read_DAT(void)
{
    if ( ReadLEN )
    {
        TblData->VG.DataIO=TblData->VG.RegData=ReadPTR[ReadOFF++];
        if ( --ReadLEN == 0)
        {
            ReadStat=0x0;
            ReadSYS=0x80;
        }
        RdFLAG=2;
    }
    else
    {
        TblData->VG.DataIO=TblData->VG.RegData;
    }
}

void Write_TRK(void) {TblData->VG.RegTrack=TblData->VG.DataIO;}
void Write_SEC(void) {TblData->VG.RegSect=TblData->VG.DataIO;}
void Write_DAT(void) {TblData->VG.RegData=TblData->VG.DataIO;}
void Write_SYS(void)
{
    byte a;
    TblData->VG.System=TblData->VG.DataIO;
    VG_Side=(TblData->VG.DataIO&0x10)>>4;

/*    if ( (a & 3) != CurrentDrive )
    {
        TrackInBuf=255;
        CurrentDrive=a&3;
    }
*/
}
void Write_CMD(void)
{
    int b4=(TblData->VG.DataIO & 0x10) >> 4;
    int a,b,c,i;
    char m1[]="00 00 00000000";

    switch ( TblData->VG.DataIO >> 5 )
    {
        case 0:
            {
                VG_IndexUse=2;

                if ( b4 ) // Seek
                {
                    a=TblData->VG.RegData;
                    b=TblData->VG.RegTrack;
                    TblData->VG.RegTrack=a;
                    c=a-b; // Seek Offset (Data - track)
                    a=TblData->VG.TrackReal[0];
                    a+=c;
                    if (a >=80) a=79;
                    if (a < 0) a=0;
                    TblData->VG.TrackReal[0]=a;

                    ReadSYS=0x80;
                    ReadStat=a?0xe0:0xe4;
                }
                else  // Restore
                {
                    TblData->VG.TrackReal[0]=0;
                    TblData->VG.RegTrack=0;
                    ReadStat=0xe4;
                    ReadSYS=0x80;
                }
                break;
            }
        case 1:  // Step StepR
            {
                VG_IndexUse=2;

                if ( b4 ) TblData->VG.RegTrack+=TblData->VG.StepDirect;

                TblData->VG.TrackReal[0]+=TblData->VG.StepDirect;
                if ( TblData->VG.TrackReal[0] == 80)
                {
                    TblData->VG.TrackReal[0]=79;
                    ReadStat=0xe0;
                }
                else if ( TblData->VG.TrackReal[0] == 255 )
                {
                    TblData->VG.TrackReal[0]=0;
                    ReadStat=0xe4;
                }
                else ReadStat=0xe0;
                break;
            }
        case 2: // Step FF _ R
            {
                VG_IndexUse=2;
                if ( b4 ) TblData->VG.RegTrack++;
                TblData->VG.StepDirect=1;
                if ( (++TblData->VG.TrackReal[0]) == 80 ) TblData->VG.TrackReal[0]--;
                ReadStat=0xe0;
                break;
            }
        case 3: // Step Back _R
            {
                VG_IndexUse=2;
                if ( b4 ) TblData->VG.RegTrack--;
                TblData->VG.StepDirect=-1;
                if ( (--TblData->VG.TrackReal[0]) == 0xff )
                {
                    TblData->VG.TrackReal[0]=0;
                    ReadStat=0xe4;
                }
                else ReadStat=0xe0;
                break;
            }
        case 4: // Read Sector (Multi)
            {
//
//                if ( TblData->VG.TrackReal[0] != TrackInBuf) ReadTrack;

                if ( b4 )
                {
                    TblData->TextMode();
                    TblData->MessageBox(0x0f,"<MULTI>","");
                    TblData->SpecMode();
                }


                a=(TblData->VG.TrackReal[0]<<1) | (VG_Side^1);

                for ( i=0;i<ftrk[a].sex;i++ )
                {
                    if ( ftrk[a].sec[i].r == TblData->VG.RegSect ) c=i;
                }

                b=((int)ftrk[a].sec[c].flags & 0x3f) * 128;


            LSeek(Handle,
                (long)fdi.data_offset +
                ftrk[a].offs +
                ftrk[a].sec[c].offs,0);

                FileRead(TRACKBUF,b,Handle);

                ReadPTR=TRACKBUF;
                ReadOFF=0;
                ReadLEN=b;
                VG_IndexUse=0;
                ReadStat=0x82;
                ReadSYS=0x40;
                RdFLAG=2;
                break;
            }
        case 5: // Write Sector (Multi)
            {
                VG_IndexUse=0;
                ReadSYS=0x80;
                ReadStat=0xc0;
                break;
            }
        case 6: // RdArrd & Break
            {
                if ( b4 ) // Break
                {
                    ReadSYS=0x80;
                    if ( TblData->VG.TrackReal[0]  ) ReadStat=0xa0;
                    else
                    {
                        VG_IndexUse=2;
                        ReadStat=0xa4;
                    }
                }
                else // RdAddr
                {
                    RDADDR[0]=TblData->VG.TrackReal[0];
                    RDADDR[1]=VG_Side;
/*
                    RDADDR[2]=ftrk[TblData->VG.TrackReal[0]].sec[SecNum].r;
                    RDADDR[3]=ftrk[TblData->VG.TrackReal[0]].sec[SecNum].n;
                    if (++SecNum>ftrk[TblData->VG.TrackReal[0]].sex) SecNum=0;
*/

                    RDADDR[2]=SecNum;
                    RDADDR[3]=1;
                    if (++SecNum>16) SecNum=0;

                    ReadPTR=RDADDR;
                    ReadOFF=0;
                    ReadLEN=6;
                    VG_IndexUse=0;
                    ReadStat=0x82;
                    ReadSYS=0x40;
                }
                break;
            }
        case 7:  // Rd & Wr Track
            {
                VG_IndexUse=0;
                ReadSYS=0x80;
                ReadStat=b4?0xc0:0x84;
                break;
            }
    }
}


byte _VG_(void)
{
    int a;

    if ( TapeSelect==0 ) return 0;

//    if ( (TblData->VG.System & 0x3 ) != 0) return 0; // Only A

    TblData->VG.RegCom=TblData->VG.OperIO;
    switch ( TblData->VG.OperIO )
    {
        case 0x0: { Read_STAT();break; };
        case 0x1: { Write_CMD();break; };

        case 0x2: { Read_TRK();break; };
        case 0x3: { Write_TRK();break; };
        case 0x4: { Read_SEC();break; };
        case 0x5: { Write_SEC();break; };

        case 0x6: { Read_DAT();break; };
        case 0x7: { Write_DAT();break; };

        case 0x8: { Read_SYS();break; };
        case 0x9: { Write_SYS();break; };

        case 0xa: { break; }
        case 0xb: { break; };
        case 0xc: { ResetVG();break; };
    }

    return 1;
}

static void WorkMenu() {

    int Result=-1;

    if ( TRACKBUF == 0 )
    {
        TblData->TextMode();
        TblData->MessageBox(0x4f,"Error: Can't allocate startup mem","");
        TblData->SpecMode();
        return;
    }

    TblData->TextMode();
    void *Pnt=TblData->WinCreate(8,8,63,12,0x9F);
    TblData->WinTitle(Pnt,_DSC,0xF4);

    TblData->WinText(Pnt,2,2,"      .FDI support by ESL. Kharkov, Ukraine, 1997.");
    TblData->WinText(Pnt,2,3,"                      FidoNet: 2:461/108.7");

    void *TxtPnt=TblData->SetInputTxt(Pnt,4,6,35,"File Name",&CtFileName);

    TblData->SetButton(Pnt,44,7,TxtBrowse,12,3);

    TblData->SetButton(Pnt,29,9,TxtCancel,12,0);
    TblData->SetButton(Pnt,13,9,TxtOk,12,1);


    while ( (Result != 0) && (Result != 1) )
    {
        if ( (Result=TblData->WinExe(Pnt)) == 3)
        {
            GetPath(FileName,Path);
            TblData->FileBox(TxtPnt,"*.fdi",Path);

       }
        TblData->WinResult(Pnt);
    }
    if (*Path) MakeFullName(FileName,Path);

    TblData->WinRemove(Pnt);
    if ( Result )
    {
        if (TapeSelect){
             FreeFDIMem();
             FileClose(Handle);
        }
        TapeSelect=0;
        if (OpenFDI(FileName)) TapeSelect=1;
    }
    TblData->SetSpec();
}

void _INI(EmuData *Pnt,unsigned IdN) {

	TblData=Pnt;
	Id=IdN;
  TRACKBUF=TblData->SpecRAM+(0x4000*0x20);

//    HandleLOG=FileCreate("FDC.LOG");
}

void _UNI() {
//    if (TRACKBUF) TblData->MemFree(TRACKBUF);
    FileClose(Handle);
//    FileClose(HandleLOG);
    FreeFDIMem();
}
void _VGP(void)
{
//    FileSave(&(TblData->VG),sizeof(DatVG),HandleLOG);
}


void _F7_() {if (Key==0) WorkMenu();}
void _F8_() {if (Key==1) WorkMenu();}
void _F9_() {if (Key==2) WorkMenu();}
void _F10() {if (Key==3) WorkMenu();}
void _F11() {if (Key==4) WorkMenu();}
void _F12() {if (Key==5) WorkMenu();}
